From b98a8b002a0fddbbd665a55abcc820273a88b0f3 Mon Sep 17 00:00:00 2001
From: Hari Babu Kommi <kommih@localhost.localdomain>
Date: Fri, 14 Jul 2017 22:13:09 +1000
Subject: [PATCH] WIP tuple replace with slot

---
 contrib/dblink/dblink.c                  |  38 ++--
 contrib/lo/lo.c                          |  24 +--
 contrib/spi/autoinc.c                    |  16 +-
 contrib/spi/insert_username.c            |  10 +-
 contrib/spi/moddatetime.c                |   9 +-
 contrib/spi/refint.c                     |  40 ++--
 contrib/spi/timetravel.c                 |  40 ++--
 contrib/tablefunc/tablefunc.c            |  34 ++--
 contrib/tcn/tcn.c                        |   6 +-
 contrib/xml2/xpath.c                     |   8 +-
 src/backend/bootstrap/bootstrap.c        |   4 +-
 src/backend/catalog/aclchk.c             |  12 +-
 src/backend/catalog/index.c              |   4 +-
 src/backend/catalog/pg_conversion.c      |   2 +-
 src/backend/catalog/pg_db_role_setting.c |   2 +-
 src/backend/catalog/pg_publication.c     |   2 +-
 src/backend/catalog/pg_subscription.c    |   2 +-
 src/backend/commands/constraint.c        |  14 +-
 src/backend/commands/copy.c              |  27 ++-
 src/backend/commands/dbcommands.c        |   1 +
 src/backend/commands/indexcmds.c         |   2 +-
 src/backend/commands/matview.c           |   2 +-
 src/backend/commands/tablecmds.c         |  14 +-
 src/backend/commands/trigger.c           | 334 +++++++++++++++++--------------
 src/backend/executor/execReplication.c   |   7 +-
 src/backend/executor/execTuples.c        |  60 ++++++
 src/backend/executor/nodeModifyTable.c   |  57 ++++--
 src/backend/executor/spi.c               |  92 +++++++--
 src/backend/replication/logical/worker.c |   1 +
 src/backend/utils/adt/ri_triggers.c      | 230 ++++++++++-----------
 src/backend/utils/adt/ruleutils.c        |  50 +++--
 src/backend/utils/adt/trigfuncs.c        |   4 +-
 src/backend/utils/adt/tsquery_rewrite.c  |   4 +-
 src/backend/utils/adt/tsvector_op.c      |  26 ++-
 src/backend/utils/adt/xml.c              |   2 -
 src/include/access/htup.h                |   1 +
 src/include/commands/trigger.h           |  26 ++-
 src/include/executor/spi.h               |   8 +-
 src/include/executor/tuptable.h          |   6 +
 src/pl/plperl/plperl.c                   |  20 +-
 src/pl/plpgsql/src/pl_comp.c             |   2 +-
 src/pl/plpgsql/src/pl_exec.c             | 102 ++++------
 src/pl/plpgsql/src/plpgsql.h             |   2 +-
 src/pl/plpython/plpy_exec.c              |  14 +-
 src/pl/tcl/pltcl.c                       |  10 +-
 src/test/modules/worker_spi/worker_spi.c |   2 -
 src/test/regress/regress.c               |  55 +++--
 47 files changed, 779 insertions(+), 649 deletions(-)

diff --git a/contrib/dblink/dblink.c b/contrib/dblink/dblink.c
index 81136b1..cad2039 100644
--- a/contrib/dblink/dblink.c
+++ b/contrib/dblink/dblink.c
@@ -107,7 +107,7 @@ static char *get_sql_delete(Relation rel, int *pkattnums, int pknumatts, char **
 static char *get_sql_update(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals, char **tgt_pkattvals);
 static char *quote_ident_cstr(char *rawstr);
 static int	get_attnum_pk_pos(int *pkattnums, int pknumatts, int key);
-static HeapTuple get_tuple_of_interest(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals);
+static TupleTableSlot* get_tuple_of_interest(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals);
 static Relation get_rel_from_relname(text *relname_text, LOCKMODE lockmode, AclMode aclmode);
 static char *generate_relation_name(Relation rel);
 static void dblink_connstr_check(const char *connstr);
@@ -2144,7 +2144,7 @@ static char *
 get_sql_insert(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals, char **tgt_pkattvals)
 {
 	char	   *relname;
-	HeapTuple	tuple;
+	TupleTableSlot *slot;
 	TupleDesc	tupdesc;
 	int			natts;
 	StringInfoData buf;
@@ -2158,15 +2158,15 @@ get_sql_insert(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals
 	/* get relation name including any needed schema prefix and quoting */
 	relname = generate_relation_name(rel);
 
-	tupdesc = rel->rd_att;
-	natts = tupdesc->natts;
-
-	tuple = get_tuple_of_interest(rel, pkattnums, pknumatts, src_pkattvals);
-	if (!tuple)
+	slot = get_tuple_of_interest(rel, pkattnums, pknumatts, src_pkattvals);
+	if (!slot)
 		ereport(ERROR,
 				(errcode(ERRCODE_CARDINALITY_VIOLATION),
 				 errmsg("source row not found")));
 
+	tupdesc = slot->tts_tupleDescriptor;
+	natts = tupdesc->natts;
+
 	appendStringInfo(&buf, "INSERT INTO %s(", relname);
 
 	needComma = false;
@@ -2202,7 +2202,7 @@ get_sql_insert(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals
 		if (key >= 0)
 			val = tgt_pkattvals[key] ? pstrdup(tgt_pkattvals[key]) : NULL;
 		else
-			val = SPI_getvalue(tuple, tupdesc, i + 1);
+			val = SPI_getvalue(slot, i + 1);
 
 		if (val != NULL)
 		{
@@ -2258,7 +2258,7 @@ static char *
 get_sql_update(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals, char **tgt_pkattvals)
 {
 	char	   *relname;
-	HeapTuple	tuple;
+	TupleTableSlot *slot;
 	TupleDesc	tupdesc;
 	int			natts;
 	StringInfoData buf;
@@ -2272,15 +2272,15 @@ get_sql_update(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals
 	/* get relation name including any needed schema prefix and quoting */
 	relname = generate_relation_name(rel);
 
-	tupdesc = rel->rd_att;
-	natts = tupdesc->natts;
-
-	tuple = get_tuple_of_interest(rel, pkattnums, pknumatts, src_pkattvals);
-	if (!tuple)
+	slot = get_tuple_of_interest(rel, pkattnums, pknumatts, src_pkattvals);
+	if (!slot)
 		ereport(ERROR,
 				(errcode(ERRCODE_CARDINALITY_VIOLATION),
 				 errmsg("source row not found")));
 
+	tupdesc = slot->tts_tupleDescriptor;
+	natts = tupdesc->natts;
+
 	appendStringInfo(&buf, "UPDATE %s SET ", relname);
 
 	/*
@@ -2303,7 +2303,7 @@ get_sql_update(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals
 		if (key >= 0)
 			val = tgt_pkattvals[key] ? pstrdup(tgt_pkattvals[key]) : NULL;
 		else
-			val = SPI_getvalue(tuple, tupdesc, i + 1);
+			val = SPI_getvalue(slot, i + 1);
 
 		if (val != NULL)
 		{
@@ -2372,7 +2372,7 @@ get_attnum_pk_pos(int *pkattnums, int pknumatts, int key)
 	return -1;
 }
 
-static HeapTuple
+static TupleTableSlot *
 get_tuple_of_interest(Relation rel, int *pkattnums, int pknumatts, char **src_pkattvals)
 {
 	char	   *relname;
@@ -2380,7 +2380,7 @@ get_tuple_of_interest(Relation rel, int *pkattnums, int pknumatts, char **src_pk
 	int			natts;
 	StringInfoData buf;
 	int			ret;
-	HeapTuple	tuple;
+	TupleTableSlot *slot;
 	int			i;
 
 	/*
@@ -2456,10 +2456,10 @@ get_tuple_of_interest(Relation rel, int *pkattnums, int pknumatts, char **src_pk
 	{
 		SPITupleTable *tuptable = SPI_tuptable;
 
-		tuple = SPI_copytuple(tuptable->vals[0]);
+		slot = tuptable->vals[0];
 		SPI_finish();
 
-		return tuple;
+		return slot;
 	}
 	else
 	{
diff --git a/contrib/lo/lo.c b/contrib/lo/lo.c
index 4585923..432bedb 100644
--- a/contrib/lo/lo.c
+++ b/contrib/lo/lo.c
@@ -27,10 +27,10 @@ lo_manage(PG_FUNCTION_ARGS)
 	int			attnum;			/* attribute number to monitor	*/
 	char	  **args;			/* Args containing attr name	*/
 	TupleDesc	tupdesc;		/* Tuple Descriptor				*/
-	HeapTuple	rettuple;		/* Tuple to be returned			*/
+	TupleTableSlot*	retslot;		/* Tuple to be returned			*/
 	bool		isdelete;		/* are we deleting?				*/
-	HeapTuple	newtuple;		/* The new value for tuple		*/
-	HeapTuple	trigtuple;		/* The original value of tuple	*/
+	TupleTableSlot*	newslot;		/* The new value for tuple		*/
+	TupleTableSlot*	trigslot;		/* The original value of tuple	*/
 
 	if (!CALLED_AS_TRIGGER(fcinfo)) /* internal error */
 		elog(ERROR, "%s: not fired by trigger manager",
@@ -43,8 +43,8 @@ lo_manage(PG_FUNCTION_ARGS)
 	/*
 	 * Fetch some values from trigdata
 	 */
-	newtuple = trigdata->tg_newtuple;
-	trigtuple = trigdata->tg_trigtuple;
+	newslot = trigdata->tg_newslot;
+	trigslot = trigdata->tg_trigslot;
 	tupdesc = trigdata->tg_relation->rd_att;
 	args = trigdata->tg_trigger->tgargs;
 
@@ -54,9 +54,9 @@ lo_manage(PG_FUNCTION_ARGS)
 
 	/* tuple to return to Executor */
 	if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
-		rettuple = newtuple;
+		retslot = newslot;
 	else
-		rettuple = trigtuple;
+		retslot = trigslot;
 
 	/* Are we deleting the row? */
 	isdelete = TRIGGER_FIRED_BY_DELETE(trigdata->tg_event);
@@ -74,10 +74,10 @@ lo_manage(PG_FUNCTION_ARGS)
 	 * Here, if the value of the monitored attribute changes, then the large
 	 * object associated with the original value is unlinked.
 	 */
-	if (newtuple != NULL)
+	if (newslot != NULL)
 	{
-		char	   *orig = SPI_getvalue(trigtuple, tupdesc, attnum);
-		char	   *newv = SPI_getvalue(newtuple, tupdesc, attnum);
+		char	   *orig = SPI_getvalue(trigslot, attnum);
+		char	   *newv = SPI_getvalue(newslot, attnum);
 
 		if (orig != NULL && (newv == NULL || strcmp(orig, newv) != 0))
 			DirectFunctionCall1(be_lo_unlink,
@@ -96,7 +96,7 @@ lo_manage(PG_FUNCTION_ARGS)
 	 */
 	if (isdelete)
 	{
-		char	   *orig = SPI_getvalue(trigtuple, tupdesc, attnum);
+		char	   *orig = SPI_getvalue(trigslot, attnum);
 
 		if (orig != NULL)
 		{
@@ -107,5 +107,5 @@ lo_manage(PG_FUNCTION_ARGS)
 		}
 	}
 
-	return PointerGetDatum(rettuple);
+	return PointerGetDatum(retslot->tts_storageam->slot_get_tuple(retslot));
 }
diff --git a/contrib/spi/autoinc.c b/contrib/spi/autoinc.c
index 8bf7422..b4a207e 100644
--- a/contrib/spi/autoinc.c
+++ b/contrib/spi/autoinc.c
@@ -28,7 +28,7 @@ autoinc(PG_FUNCTION_ARGS)
 	char	  **args;			/* arguments */
 	char	   *relname;		/* triggered relation name */
 	Relation	rel;			/* triggered relation */
-	HeapTuple	rettuple = NULL;
+	TupleTableSlot *retslot = NULL;
 	TupleDesc	tupdesc;		/* tuple description */
 	bool		isnull;
 	int			i;
@@ -44,9 +44,9 @@ autoinc(PG_FUNCTION_ARGS)
 		elog(ERROR, "must be fired before event");
 
 	if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
-		rettuple = trigdata->tg_trigtuple;
+		retslot = trigdata->tg_trigslot;
 	else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
-		rettuple = trigdata->tg_newtuple;
+		retslot = trigdata->tg_newslot;
 	else
 		/* internal error */
 		elog(ERROR, "cannot process DELETE events");
@@ -86,7 +86,7 @@ autoinc(PG_FUNCTION_ARGS)
 					 errmsg("attribute \"%s\" of \"%s\" must be type INT4",
 							args[i], relname)));
 
-		val = DatumGetInt32(SPI_getbinval(rettuple, tupdesc, attnum, &isnull));
+		val = DatumGetInt32(SPI_getbinval(retslot, attnum, &isnull));
 
 		if (!isnull && val != 0)
 		{
@@ -113,9 +113,9 @@ autoinc(PG_FUNCTION_ARGS)
 
 	if (chnattrs > 0)
 	{
-		rettuple = heap_modify_tuple_by_cols(rettuple, tupdesc,
-											 chnattrs, chattrs,
-											 newvals, newnulls);
+		retslot = heap_modify_slot_by_cols(retslot,
+											chnattrs, chattrs,
+											newvals, newnulls);
 	}
 
 	pfree(relname);
@@ -123,5 +123,5 @@ autoinc(PG_FUNCTION_ARGS)
 	pfree(newvals);
 	pfree(newnulls);
 
-	return PointerGetDatum(rettuple);
+	return PointerGetDatum(retslot->tts_tuple);
 }
diff --git a/contrib/spi/insert_username.c b/contrib/spi/insert_username.c
index a2e1747..f3093ed 100644
--- a/contrib/spi/insert_username.c
+++ b/contrib/spi/insert_username.c
@@ -29,7 +29,7 @@ insert_username(PG_FUNCTION_ARGS)
 	char	  **args;			/* arguments */
 	char	   *relname;		/* triggered relation name */
 	Relation	rel;			/* triggered relation */
-	HeapTuple	rettuple = NULL;
+	TupleTableSlot *retslot;
 	TupleDesc	tupdesc;		/* tuple description */
 	int			attnum;
 
@@ -45,9 +45,9 @@ insert_username(PG_FUNCTION_ARGS)
 		elog(ERROR, "insert_username: must be fired before event");
 
 	if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
-		rettuple = trigdata->tg_trigtuple;
+		retslot = trigdata->tg_trigslot;
 	else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
-		rettuple = trigdata->tg_newtuple;
+		retslot = trigdata->tg_newslot;
 	else
 		/* internal error */
 		elog(ERROR, "insert_username: cannot process DELETE events");
@@ -83,10 +83,10 @@ insert_username(PG_FUNCTION_ARGS)
 	newnull = false;
 
 	/* construct new tuple */
-	rettuple = heap_modify_tuple_by_cols(rettuple, tupdesc,
+	retslot = heap_modify_slot_by_cols(retslot,
 										 1, &attnum, &newval, &newnull);
 
 	pfree(relname);
 
-	return PointerGetDatum(rettuple);
+	return PointerGetDatum(retslot->tts_tuple);
 }
diff --git a/contrib/spi/moddatetime.c b/contrib/spi/moddatetime.c
index 70476f7..2ab74a7 100644
--- a/contrib/spi/moddatetime.c
+++ b/contrib/spi/moddatetime.c
@@ -39,7 +39,7 @@ moddatetime(PG_FUNCTION_ARGS)
 	char	  **args;			/* arguments */
 	char	   *relname;		/* triggered relation name */
 	Relation	rel;			/* triggered relation */
-	HeapTuple	rettuple = NULL;
+	TupleTableSlot *slot;
 	TupleDesc	tupdesc;		/* tuple description */
 
 	if (!CALLED_AS_TRIGGER(fcinfo))
@@ -58,7 +58,7 @@ moddatetime(PG_FUNCTION_ARGS)
 		/* internal error */
 		elog(ERROR, "moddatetime: cannot process INSERT events");
 	else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
-		rettuple = trigdata->tg_newtuple;
+		slot = trigdata->tg_newslot;
 	else
 		/* internal error */
 		elog(ERROR, "moddatetime: cannot process DELETE events");
@@ -120,11 +120,10 @@ moddatetime(PG_FUNCTION_ARGS)
 	newdtnull = false;
 
 	/* Replace the attnum'th column with newdt */
-	rettuple = heap_modify_tuple_by_cols(rettuple, tupdesc,
-										 1, &attnum, &newdt, &newdtnull);
+	slot = heap_modify_slot_by_cols(slot, 1, &attnum, &newdt, &newdtnull);
 
 	/* Clean up */
 	pfree(relname);
 
-	return PointerGetDatum(rettuple);
+	return PointerGetDatum(slot->tts_tuple);
 }
diff --git a/contrib/spi/refint.c b/contrib/spi/refint.c
index 46205c7..0d87f59 100644
--- a/contrib/spi/refint.c
+++ b/contrib/spi/refint.c
@@ -53,7 +53,7 @@ check_primary_key(PG_FUNCTION_ARGS)
 	Datum	   *kvals;			/* key values */
 	char	   *relname;		/* referenced relation name */
 	Relation	rel;			/* triggered relation */
-	HeapTuple	tuple = NULL;	/* tuple to return */
+	TupleTableSlot *slot = NULL; /* tuple to return */
 	TupleDesc	tupdesc;		/* tuple description */
 	EPlan	   *plan;			/* prepared plan */
 	Oid		   *argtypes = NULL;	/* key types to prepare execution plan */
@@ -82,7 +82,7 @@ check_primary_key(PG_FUNCTION_ARGS)
 
 	/* If INSERTion then must check Tuple to being inserted */
 	if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
-		tuple = trigdata->tg_trigtuple;
+		slot = trigdata->tg_trigslot;
 
 	/* Not should be called for DELETE */
 	else if (TRIGGER_FIRED_BY_DELETE(trigdata->tg_event))
@@ -91,7 +91,7 @@ check_primary_key(PG_FUNCTION_ARGS)
 
 	/* If UPDATE, then must check new Tuple, not old one */
 	else
-		tuple = trigdata->tg_newtuple;
+		slot = trigdata->tg_newslot;
 
 	trigger = trigdata->tg_trigger;
 	nargs = trigger->tgnargs;
@@ -142,7 +142,7 @@ check_primary_key(PG_FUNCTION_ARGS)
 							args[i], SPI_getrelname(rel))));
 
 		/* Well, get binary (in internal format) value of column */
-		kvals[i] = SPI_getbinval(tuple, tupdesc, fnumber, &isnull);
+		kvals[i] = SPI_getbinval(slot, fnumber, &isnull);
 
 		/*
 		 * If it's NULL then nothing to do! DON'T FORGET call SPI_finish ()!
@@ -152,7 +152,7 @@ check_primary_key(PG_FUNCTION_ARGS)
 		if (isnull)
 		{
 			SPI_finish();
-			return PointerGetDatum(tuple);
+			return PointerGetDatum(slot->tts_tuple);
 		}
 
 		if (plan->nplans <= 0)	/* Get typeId of column */
@@ -217,7 +217,7 @@ check_primary_key(PG_FUNCTION_ARGS)
 
 	SPI_finish();
 
-	return PointerGetDatum(tuple);
+	return PointerGetDatum(slot->tts_tuple);
 }
 
 /*
@@ -248,8 +248,8 @@ check_foreign_key(PG_FUNCTION_ARGS)
 	Datum	   *kvals;			/* key values */
 	char	   *relname;		/* referencing relation name */
 	Relation	rel;			/* triggered relation */
-	HeapTuple	trigtuple = NULL;	/* tuple to being changed */
-	HeapTuple	newtuple = NULL;	/* tuple to return */
+	TupleTableSlot*	trigslot = NULL;		/* tuple to being changed */
+	TupleTableSlot*	newslot = NULL;	/* tuple to return */
 	TupleDesc	tupdesc;		/* tuple description */
 	EPlan	   *plan;			/* prepared plan(s) */
 	Oid		   *argtypes = NULL;	/* key types to prepare execution plan */
@@ -285,7 +285,7 @@ check_foreign_key(PG_FUNCTION_ARGS)
 		elog(ERROR, "check_foreign_key: cannot process INSERT events");
 
 	/* Have to check tg_trigtuple - tuple being deleted */
-	trigtuple = trigdata->tg_trigtuple;
+	trigslot = trigdata->tg_trigslot;
 
 	/*
 	 * But if this is UPDATE then we have to return tg_newtuple. Also, if key
@@ -294,7 +294,7 @@ check_foreign_key(PG_FUNCTION_ARGS)
 	is_update = 0;
 	if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
 	{
-		newtuple = trigdata->tg_newtuple;
+		newslot = trigdata->tg_newslot;
 		is_update = 1;
 	}
 	trigger = trigdata->tg_trigger;
@@ -369,7 +369,7 @@ check_foreign_key(PG_FUNCTION_ARGS)
 							args[i], SPI_getrelname(rel))));
 
 		/* Well, get binary (in internal format) value of column */
-		kvals[i] = SPI_getbinval(trigtuple, tupdesc, fnumber, &isnull);
+		kvals[i] = SPI_getbinval(trigslot, fnumber, &isnull);
 
 		/*
 		 * If it's NULL then nothing to do! DON'T FORGET call SPI_finish ()!
@@ -379,7 +379,8 @@ check_foreign_key(PG_FUNCTION_ARGS)
 		if (isnull)
 		{
 			SPI_finish();
-			return PointerGetDatum((newtuple == NULL) ? trigtuple : newtuple);
+			return PointerGetDatum((newslot == NULL) ?
+					trigslot->tts_tuple : newslot->tts_tuple);
 		}
 
 		/*
@@ -387,16 +388,16 @@ check_foreign_key(PG_FUNCTION_ARGS)
 		 * compare is this the same as old one. For the moment we use string
 		 * presentation of values...
 		 */
-		if (newtuple != NULL)
+		if (newslot != NULL)
 		{
-			char	   *oldval = SPI_getvalue(trigtuple, tupdesc, fnumber);
+			char	   *oldval = SPI_getvalue(trigslot, fnumber);
 			char	   *newval;
 
 			/* this shouldn't happen! SPI_ERROR_NOOUTFUNC ? */
 			if (oldval == NULL)
 				/* internal error */
 				elog(ERROR, "check_foreign_key: SPI_getvalue returned %d", SPI_result);
-			newval = SPI_getvalue(newtuple, tupdesc, fnumber);
+			newval = SPI_getvalue(newslot, fnumber);
 			if (newval == NULL || strcmp(oldval, newval) != 0)
 				isequal = false;
 		}
@@ -470,7 +471,7 @@ check_foreign_key(PG_FUNCTION_ARGS)
 
 						fn = SPI_fnumber(tupdesc, args_temp[k - 1]);
 						Assert(fn > 0); /* already checked above */
-						nv = SPI_getvalue(newtuple, tupdesc, fn);
+						nv = SPI_getvalue(newslot, fn);
 						type = SPI_gettype(tupdesc, fn);
 
 						if ((strcmp(type, "text") && strcmp(type, "varchar") &&
@@ -552,10 +553,10 @@ check_foreign_key(PG_FUNCTION_ARGS)
 	/*
 	 * If UPDATE and key is not changed ...
 	 */
-	if (newtuple != NULL && isequal)
+	if (newslot != NULL && isequal)
 	{
 		SPI_finish();
-		return PointerGetDatum(newtuple);
+		return PointerGetDatum(newslot->tts_tuple);
 	}
 
 	/*
@@ -604,7 +605,8 @@ check_foreign_key(PG_FUNCTION_ARGS)
 
 	SPI_finish();
 
-	return PointerGetDatum((newtuple == NULL) ? trigtuple : newtuple);
+	return PointerGetDatum((newslot == NULL) ?
+							trigslot->tts_tuple : newslot->tts_tuple);
 }
 
 static EPlan *
diff --git a/contrib/spi/timetravel.c b/contrib/spi/timetravel.c
index f7905e2..2127cd6 100644
--- a/contrib/spi/timetravel.c
+++ b/contrib/spi/timetravel.c
@@ -96,8 +96,8 @@ timetravel(PG_FUNCTION_ARGS)
 	char	   *cnulls;			/* column nulls */
 	char	   *relname;		/* triggered relation name */
 	Relation	rel;			/* triggered relation */
-	HeapTuple	trigtuple;
-	HeapTuple	newtuple = NULL;
+	TupleTableSlot *trigslot;
+	TupleTableSlot *newslot = NULL;
 	HeapTuple	rettuple;
 	TupleDesc	tupdesc;		/* tuple description */
 	int			natts;			/* # of attributes */
@@ -129,9 +129,9 @@ timetravel(PG_FUNCTION_ARGS)
 		isinsert = true;
 
 	if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
-		newtuple = trigdata->tg_newtuple;
+		newslot = trigdata->tg_newslot;
 
-	trigtuple = trigdata->tg_trigtuple;
+	trigslot = trigdata->tg_trigslot;
 
 	rel = trigdata->tg_relation;
 	relname = SPI_getrelname(rel);
@@ -141,7 +141,8 @@ timetravel(PG_FUNCTION_ARGS)
 	{
 		/* OFF - nothing to do */
 		pfree(relname);
-		return PointerGetDatum((newtuple != NULL) ? newtuple : trigtuple);
+		return PointerGetDatum((newslot != NULL) ?
+				newslot->tts_tuple : trigslot->tts_tuple);
 	}
 
 	trigger = trigdata->tg_trigger;
@@ -186,7 +187,7 @@ timetravel(PG_FUNCTION_ARGS)
 		Datum		newvals[MaxAttrNum];
 		bool		newnulls[MaxAttrNum];
 
-		oldtimeon = SPI_getbinval(trigtuple, tupdesc, attnum[a_time_on], &isnull);
+		oldtimeon = SPI_getbinval(trigslot, attnum[a_time_on], &isnull);
 		if (isnull)
 		{
 			newvals[chnattrs] = GetCurrentAbsoluteTime();
@@ -195,7 +196,7 @@ timetravel(PG_FUNCTION_ARGS)
 			chnattrs++;
 		}
 
-		oldtimeoff = SPI_getbinval(trigtuple, tupdesc, attnum[a_time_off], &isnull);
+		oldtimeoff = SPI_getbinval(trigslot, attnum[a_time_off], &isnull);
 		if (isnull)
 		{
 			if ((chnattrs == 0 && DatumGetInt32(oldtimeon) >= NOEND_ABSTIME) ||
@@ -215,7 +216,7 @@ timetravel(PG_FUNCTION_ARGS)
 
 		pfree(relname);
 		if (chnattrs <= 0)
-			return PointerGetDatum(trigtuple);
+			return PointerGetDatum(trigslot->tts_tuple);
 
 		if (argc == MaxAttrNum)
 		{
@@ -235,7 +236,8 @@ timetravel(PG_FUNCTION_ARGS)
 			chattrs[chnattrs] = attnum[a_ins_user];
 			chnattrs++;
 		}
-		rettuple = heap_modify_tuple_by_cols(trigtuple, tupdesc,
+		rettuple = heap_modify_tuple_by_cols(trigslot->tts_tuple,
+											 tupdesc,
 											 chnattrs, chattrs,
 											 newvals, newnulls);
 		return PointerGetDatum(rettuple);
@@ -243,11 +245,11 @@ timetravel(PG_FUNCTION_ARGS)
 	}
 
 	/* UPDATE/DELETE: */
-	oldtimeon = SPI_getbinval(trigtuple, tupdesc, attnum[a_time_on], &isnull);
+	oldtimeon = SPI_getbinval(trigslot, attnum[a_time_on], &isnull);
 	if (isnull)
 		elog(ERROR, "timetravel (%s): %s must be NOT NULL", relname, args[a_time_on]);
 
-	oldtimeoff = SPI_getbinval(trigtuple, tupdesc, attnum[a_time_off], &isnull);
+	oldtimeoff = SPI_getbinval(trigslot, attnum[a_time_off], &isnull);
 	if (isnull)
 		elog(ERROR, "timetravel (%s): %s must be NOT NULL", relname, args[a_time_off]);
 
@@ -255,13 +257,13 @@ timetravel(PG_FUNCTION_ARGS)
 	 * If DELETE/UPDATE of tuple with stop_date neq INFINITY then say upper
 	 * Executor to skip operation for this tuple
 	 */
-	if (newtuple != NULL)
+	if (newslot != NULL)
 	{							/* UPDATE */
-		newtimeon = SPI_getbinval(newtuple, tupdesc, attnum[a_time_on], &isnull);
+		newtimeon = SPI_getbinval(newslot, attnum[a_time_on], &isnull);
 		if (isnull)
 			elog(ERROR, "timetravel (%s): %s must be NOT NULL", relname, args[a_time_on]);
 
-		newtimeoff = SPI_getbinval(newtuple, tupdesc, attnum[a_time_off], &isnull);
+		newtimeoff = SPI_getbinval(newslot, attnum[a_time_off], &isnull);
 		if (isnull)
 			elog(ERROR, "timetravel (%s): %s must be NOT NULL", relname, args[a_time_off]);
 
@@ -286,7 +288,7 @@ timetravel(PG_FUNCTION_ARGS)
 	cnulls = (char *) palloc(natts * sizeof(char));
 	for (i = 0; i < natts; i++)
 	{
-		cvals[i] = SPI_getbinval(trigtuple, tupdesc, i + 1, &isnull);
+		cvals[i] = SPI_getbinval(trigslot, i + 1, &isnull);
 		cnulls[i] = (isnull) ? 'n' : ' ';
 	}
 
@@ -294,7 +296,7 @@ timetravel(PG_FUNCTION_ARGS)
 	cvals[attnum[a_time_off] - 1] = newtimeoff; /* stop_date eq current date */
 	cnulls[attnum[a_time_off] - 1] = ' ';
 
-	if (!newtuple)
+	if (!newslot)
 	{							/* DELETE */
 		if (argc == MaxAttrNum)
 		{
@@ -362,7 +364,7 @@ timetravel(PG_FUNCTION_ARGS)
 		elog(ERROR, "timetravel (%s): SPI_execp returned %d", relname, ret);
 
 	/* Tuple to return to upper Executor ... */
-	if (newtuple)
+	if (newslot)
 	{							/* UPDATE */
 		int			chnattrs = 0;
 		int			chattrs[MaxAttrNum];
@@ -402,11 +404,11 @@ timetravel(PG_FUNCTION_ARGS)
 		 * Use SPI_modifytuple() here because we are inside SPI environment
 		 * but rettuple must be allocated in caller's context.
 		 */
-		rettuple = SPI_modifytuple(rel, newtuple, chnattrs, chattrs, newvals, newnulls);
+		rettuple = SPI_modifytuple(rel, newslot->tts_tuple, chnattrs, chattrs, newvals, newnulls);
 	}
 	else
 		/* DELETE case */
-		rettuple = trigtuple;
+		rettuple = trigslot->tts_tuple;
 
 	SPI_finish();				/* don't forget say Bye to SPI mgr */
 
diff --git a/contrib/tablefunc/tablefunc.c b/contrib/tablefunc/tablefunc.c
index 0bc8177..cd11947 100644
--- a/contrib/tablefunc/tablefunc.c
+++ b/contrib/tablefunc/tablefunc.c
@@ -492,7 +492,7 @@ crosstab(PG_FUNCTION_ARGS)
 		 */
 		for (i = 0; i < num_categories; i++)
 		{
-			HeapTuple	spi_tuple;
+			TupleTableSlot*	spislot;
 			char	   *rowid;
 
 			/* see if we've gone too far already */
@@ -500,10 +500,10 @@ crosstab(PG_FUNCTION_ARGS)
 				break;
 
 			/* get the next sql result tuple */
-			spi_tuple = spi_tuptable->vals[call_cntr];
+			spislot = spi_tuptable->vals[call_cntr];
 
 			/* get the rowid from the current sql result tuple */
-			rowid = SPI_getvalue(spi_tuple, spi_tupdesc, 1);
+			rowid = SPI_getvalue(spislot, 1);
 
 			/*
 			 * If this is the first pass through the values for this rowid,
@@ -538,7 +538,7 @@ crosstab(PG_FUNCTION_ARGS)
 				 * Be careful to assign the value to the array index based on
 				 * which category we are presently processing.
 				 */
-				values[1 + i] = SPI_getvalue(spi_tuple, spi_tupdesc, 3);
+				values[1 + i] = SPI_getvalue(spislot, 3);
 
 				/*
 				 * increment the counter since we consume a row for each
@@ -756,13 +756,13 @@ load_categories_hash(char *cats_sql, MemoryContext per_query_ctx)
 		{
 			crosstab_cat_desc *catdesc;
 			char	   *catname;
-			HeapTuple	spi_tuple;
+			TupleTableSlot*	spislot;
 
 			/* get the next sql result tuple */
-			spi_tuple = spi_tuptable->vals[i];
+			spislot = spi_tuptable->vals[i];
 
 			/* get the category from the current sql result tuple */
-			catname = SPI_getvalue(spi_tuple, spi_tupdesc, 1);
+			catname = SPI_getvalue(spislot, 1);
 
 			SPIcontext = MemoryContextSwitchTo(per_query_ctx);
 
@@ -875,15 +875,15 @@ get_crosstab_tuplestore(char *sql,
 
 		for (i = 0; i < proc; i++)
 		{
-			HeapTuple	spi_tuple;
+			TupleTableSlot*	spislot;
 			crosstab_cat_desc *catdesc;
 			char	   *catname;
 
 			/* get the next sql result tuple */
-			spi_tuple = spi_tuptable->vals[i];
+			spislot = spi_tuptable->vals[i];
 
 			/* get the rowid from the current sql result tuple */
-			rowid = SPI_getvalue(spi_tuple, spi_tupdesc, 1);
+			rowid = SPI_getvalue(spislot, 1);
 
 			/*
 			 * if we're on a new output row, grab the column values up to
@@ -908,14 +908,14 @@ get_crosstab_tuplestore(char *sql,
 
 				values[0] = rowid;
 				for (j = 1; j < ncols - 2; j++)
-					values[j] = SPI_getvalue(spi_tuple, spi_tupdesc, j + 1);
+					values[j] = SPI_getvalue(spislot, j + 1);
 
 				/* we're no longer on the first pass */
 				firstpass = false;
 			}
 
 			/* look up the category and fill in the appropriate column */
-			catname = SPI_getvalue(spi_tuple, spi_tupdesc, ncols - 1);
+			catname = SPI_getvalue(spislot, ncols - 1);
 
 			if (catname != NULL)
 			{
@@ -923,7 +923,7 @@ get_crosstab_tuplestore(char *sql,
 
 				if (catdesc)
 					values[catdesc->attidx + ncols - 2] =
-						SPI_getvalue(spi_tuple, spi_tupdesc, ncols);
+						SPI_getvalue(spislot, ncols);
 			}
 
 			xpfree(lastrowid);
@@ -1310,7 +1310,7 @@ build_tuplestore_recursively(char *key_fld,
 	/* Check for qualifying tuples */
 	if ((ret == SPI_OK_SELECT) && (proc > 0))
 	{
-		HeapTuple	spi_tuple;
+		TupleTableSlot*	spislot;
 		SPITupleTable *tuptable = SPI_tuptable;
 		TupleDesc	spi_tupdesc = tuptable->tupdesc;
 		uint64		i;
@@ -1335,13 +1335,13 @@ build_tuplestore_recursively(char *key_fld,
 			appendStringInfo(&chk_branchstr, "%s%s%s", branch_delim, branch, branch_delim);
 
 			/* get the next sql result tuple */
-			spi_tuple = tuptable->vals[i];
+			spislot = tuptable->vals[i];
 
 			/* get the current key (might be NULL) */
-			current_key = SPI_getvalue(spi_tuple, spi_tupdesc, 1);
+			current_key = SPI_getvalue(spislot, 1);
 
 			/* get the parent key (might be NULL) */
-			current_key_parent = SPI_getvalue(spi_tuple, spi_tupdesc, 2);
+			current_key_parent = SPI_getvalue(spislot, 2);
 
 			/* get the current level */
 			sprintf(current_level, "%d", level);
diff --git a/contrib/tcn/tcn.c b/contrib/tcn/tcn.c
index 0b9acbf..c311a3b 100644
--- a/contrib/tcn/tcn.c
+++ b/contrib/tcn/tcn.c
@@ -58,7 +58,7 @@ triggered_change_notification(PG_FUNCTION_ARGS)
 	TriggerData *trigdata = (TriggerData *) fcinfo->context;
 	Trigger    *trigger;
 	int			nargs;
-	HeapTuple	trigtuple;
+	TupleTableSlot*	trigslot;
 	Relation	rel;
 	TupleDesc	tupdesc;
 	char	   *channel;
@@ -112,7 +112,7 @@ triggered_change_notification(PG_FUNCTION_ARGS)
 		channel = trigger->tgargs[0];
 
 	/* get tuple data */
-	trigtuple = trigdata->tg_trigtuple;
+	trigslot = trigdata->tg_trigslot;
 	rel = trigdata->tg_relation;
 	tupdesc = rel->rd_att;
 
@@ -157,7 +157,7 @@ triggered_change_notification(PG_FUNCTION_ARGS)
 					appendStringInfoCharMacro(payload, ',');
 					strcpy_quoted(payload, NameStr((tupdesc->attrs[colno - 1])->attname), '"');
 					appendStringInfoCharMacro(payload, '=');
-					strcpy_quoted(payload, SPI_getvalue(trigtuple, tupdesc, colno), '\'');
+					strcpy_quoted(payload, SPI_getvalue(trigslot, colno), '\'');
 				}
 
 				Async_Notify(channel, payload->data);
diff --git a/contrib/xml2/xpath.c b/contrib/xml2/xpath.c
index 95e580d..b344d1f 100644
--- a/contrib/xml2/xpath.c
+++ b/contrib/xml2/xpath.c
@@ -533,7 +533,7 @@ xpath_table(PG_FUNCTION_ARGS)
 
 	/* SPI (input tuple) support */
 	SPITupleTable *tuptable;
-	HeapTuple	spi_tuple;
+	TupleTableSlot*	spislot;
 	TupleDesc	spi_tupdesc;
 
 	/* Output tuple (tuplestore) support */
@@ -702,9 +702,9 @@ xpath_table(PG_FUNCTION_ARGS)
 			xmlXPathCompExprPtr comppath;
 
 			/* Extract the row data as C Strings */
-			spi_tuple = tuptable->vals[i];
-			pkey = SPI_getvalue(spi_tuple, spi_tupdesc, 1);
-			xmldoc = SPI_getvalue(spi_tuple, spi_tupdesc, 2);
+			spislot = tuptable->vals[i];
+			pkey = SPI_getvalue(spislot, 1);
+			xmldoc = SPI_getvalue(spislot, 2);
 
 			/*
 			 * Clear the values array, so that not-well-formed documents
diff --git a/src/backend/catalog/aclchk.c b/src/backend/catalog/aclchk.c
index ccde66a..38a1d06 100644
--- a/src/backend/catalog/aclchk.c
+++ b/src/backend/catalog/aclchk.c
@@ -789,7 +789,7 @@ objectsInSchemaToOids(GrantObjectType objtype, List *nspnames)
 					ScanKeyData key[1];
 					Relation	rel;
 					HeapScanDesc scan;
-					HeapTuple	tuple;
+					HeapTuple tup;
 
 					ScanKeyInit(&key[0],
 								Anum_pg_proc_pronamespace,
@@ -799,9 +799,9 @@ objectsInSchemaToOids(GrantObjectType objtype, List *nspnames)
 					rel = heap_open(ProcedureRelationId, AccessShareLock);
 					scan = heap_beginscan_catalog(rel, 1, key);
 
-					while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
+					while ((tup = heap_getnext(scan, ForwardScanDirection)) != NULL)
 					{
-						objects = lappend_oid(objects, HeapTupleGetOid(tuple));
+						objects = lappend_oid(objects, HeapTupleGetOid(tup));
 					}
 
 					heap_endscan(scan);
@@ -830,7 +830,7 @@ getRelationsInNamespace(Oid namespaceId, char relkind)
 	ScanKeyData key[2];
 	Relation	rel;
 	HeapScanDesc scan;
-	HeapTuple	tuple;
+	HeapTuple tup;
 
 	ScanKeyInit(&key[0],
 				Anum_pg_class_relnamespace,
@@ -844,9 +844,9 @@ getRelationsInNamespace(Oid namespaceId, char relkind)
 	rel = heap_open(RelationRelationId, AccessShareLock);
 	scan = heap_beginscan_catalog(rel, 2, key);
 
-	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
+	while ((tup = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		relations = lappend_oid(relations, HeapTupleGetOid(tuple));
+		relations = lappend_oid(relations, HeapTupleGetOid(tup));
 	}
 
 	heap_endscan(scan);
